package com.iamberry.wechat.handles.admin;

import com.iamberry.wechat.core.entity.PageBean;
import com.iamberry.wechat.core.entity.ResultMsg;
import com.iamberry.wechat.core.entity.agentInfo.AgentConfig;
import com.iamberry.wechat.core.entity.agentInfo.AgentTooth;
import com.iamberry.wechat.core.entity.product.ProductColor;
import com.iamberry.wechat.face.agentInfo.AgentInfoService;
import com.iamberry.wechat.face.porduct.ProductColorService;
import com.iamberry.wechat.tools.ResultInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 代理商逻辑处理类
 * Created by liuzhiwei on 2017/10/11.
 */
@Controller
@RequestMapping("/admin/agentTooth")
public class AdminAgentToothHandler {

    @Autowired
    private AgentInfoService agentInfoService;
    @Autowired
    private ProductColorService productColorService;

    @RequestMapping("/select_agent_config_list")
    public ModelAndView selectAgentConfigList(HttpServletRequest request,
                                              @RequestParam(value = "pageSize", defaultValue = "10", required = false) Integer pageSize,
                                              @RequestParam(value = "pageNO", defaultValue = "1", required = false) Integer pageNO) throws Exception {
        ModelAndView mv = new ModelAndView("admin/agentInfo/agentConfigList");
        StringBuilder url = new StringBuilder("/admin/agentTooth/select_agent_config_list");
        AgentConfig config = new AgentConfig();
        PageBean page = new PageBean();
        page.setPageSize(pageSize);
        page.setPageNumber(pageNO);
        page.initRecordBegin();
        config.setPage(page);
        //查询代理商配置金额集合
        List<AgentConfig> configList = agentInfoService.listAgentConfig(config);
        mv.addObject("configList", configList);
        mv.addObject("pageNO", pageNO);
        return mv;
    }

    @RequestMapping("/_add_agent_config")
    public ModelAndView addAgentConfigUI(HttpServletRequest request) throws Exception {
        ModelAndView mv = new ModelAndView("admin/agentInfo/addAgentConfig");
        return mv;
    }

    /**
     * 查询商品列表
     * @param request
     * @return
     * @throws Exception
     */
    @ResponseBody
    @RequestMapping("/select_agent_and_product")
    public ResultMsg selectAgentAndProduct(HttpServletRequest request) throws Exception {
        ResultMsg msg = new ResultMsg();
        Map<String,Object> map = new HashMap<String,Object>();
        ProductColor productColor = new ProductColor();
        productColor.setPage(null);
        List<ProductColor> colorList = productColorService.selectProductColorList(productColor);
        if (colorList == null || colorList.size() <= 0) {
            msg.setStatus(false);
        }
        AgentTooth agent = new AgentTooth();
        agent.setAgentStatus(1);
        List<AgentTooth> agentList = agentInfoService.listAgentTooth(agent);
        map.put("colorList",colorList);
        map.put("agentList",agentList);
        msg.setData(map);
        msg.setStatus(true);
        msg.setResultCode(ResultInfo.SUCCESSCODE);
        return msg;
    }
}
